Load tab items dynamically in EJ2 JavaScript Tab control

2 May 20238 minutes to read

Tabs can be added dynamically by passing array of items and index value to the addTab method.

    // New tab title and content inputs are fetched and stored in local variable
    let title: string = document.getElementById('tab-title').value;
    let content: string = document.getElementById('tab-content').value;

    // Required tab item object formed by using textbox inputs
    let item: Object =  { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

    // Item object and the index argument passed into the addTab method to add a new tab
    tabObj.addTab([item], index);

In the following demo, you can add the tab content by clicking the +. This + icon is added on the tab header using iconCss property. Enter the new Tab heading and content details in the available text boxes, click ‘Add Tab’ button to pass the details as an array and here last index is calculated to append the new tab at the end.

ej.base.enableRipple(true);

var totalItems = 0;

//Initialize Tab component
var tabObj = new ej.navigations.Tab({
    selected: tabSelected,
    items: [
        {
            header: { 'text': 'Twitter' },
            content: '#tab1_content'
        },
        {
            header: { 'iconCss': 'e-add-icon' },
            content: '#form-container'
        }
    ]
  });
//Render initialized Tab component
tabObj.appendTo('#element');

var addBtn = document.querySelectorAll(".e-ileft.e-icon");
addBtn[0].setAttribute("title", "Add Tab");

function tabSelected(args) {
    if (args.selectedIndex === document.querySelectorAll('#element .e-toolbar-item').length -1) {
        document.getElementById('tab-title').value = '';
        document.getElementById('tab-content').value = '';
    }
}

document.getElementById('btn-add').onclick = function(e) {
    var title = document.getElementById('tab-title').value;
    var content = document.getElementById('tab-content').value;
    // Required tab item object formed by using textbox inputs
    var item = { header: { text: title }, content: ej.base.createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

    totalItems = document.querySelectorAll('#element .e-toolbar-item').length;
    // Item object and the index argument passed into the addTab method to add a new tab
    tabObj.addTab([item], totalItems-1);
};
<!DOCTYPE html><html lang="en"><head>
    <title>Essential JS 2 Tab</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Tab">
    <meta name="author" content="Syncfusion">
    <link href="https://cdn.syncfusion.com/ej2/25.1.35/material.css" rel="stylesheet">
    <link href="index.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/25.1.35/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="tab1_content" style="display: none">
            <ul>
                <li>Click on the "+" header to add dynamic tab items. </li>
                <li>It displays input elements to get the new tab information. </li>
                <li>Add details and click the "Add Tab" button to open the newly added tab.</li>
            </ul>
        </div>
        <div id="form-container" style="display: none">
            <div class="e-float-input">
                <input type="text" id="tab-title" required="">
                <span class="e-float-line"></span>
                <label class="e-float-text">Enter header title</label>
            </div>
            <br>
            <div class="e-float-input">
                <textarea rows="5" type="text" id="tab-content" required=""></textarea>
                <span class="e-float-line"></span>
                <label class="e-float-text">Enter content</label>
            </div>
            <br>
            <div class="btn-section">
                <button id="btn-add" class="e-btn">Add Tab</button>
                <br>
                <br>
                <span class="info"> * Title is mandatory to add a new Tab</span>
            </div>
        </div>
        <div id="element"></div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Load tab items dynamically in Vue Tab component

25 May 202417 minutes to read

Tabs can be added dynamically by passing array of items and index value to the addTab method.

    // New tab title and content inputs are fetched and stored in local variable
    let title = document.getElementById('tab-title').value;
    let content = document.getElementById('tab-content').value;
    var tabObj = this.$refs.TabInstance.ej2Instances;

    // Required tab item object formed by using textbox inputs
    let item =  { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

    // Item object and the index argument passed into the addTab method to add a new tab
    tabObj.addTab([item], totalItems-1);

In the following demo, you can add the tab content by clicking the +. Enter the new Tab heading and content details in the available text boxes, click ‘Add Tab’ button to pass the details as an array and here last index is calculated to append the new tab at the end.

<template>
    <div id="app">
        <div id='tab1_content' style='display: none'>
            <ul>
                <li>Click on the "+" header to add dynamic tab items. </li>
                <li>It displays input elements to get the new tab information. </li>
                <li>Add details and click the "Add Tab" button to open the newly added tab.</li>
            </ul>
        </div>
        <div id='form-container' style='display: none'>
            <div class='e-float-input'>
                <input type='text' id='tab-title' required="" />
                <span class='e-float-line'></span>
                <label class='e-float-text'>Enter header title</label>
            </div>
            <br />
            <div class='e-float-input'>
                <textarea rows='5' type='text' id='tab-content' required=""></textarea>
                <span class='e-float-line'></span>
                <label class='e-float-text'>Enter content</label>
            </div>
            <br />
            <div class='btn-section'>
                <button id='btn-add' class='e-btn' v-on:click='btnClicked'>Add Tab</button>
                <br />
                <br />
                <span class='info'> * Title is mandatory to add a new Tab</span>
            </div>
        </div>
        <ejs-tab id='dynamic_tab' ref='TabInstance' :selected="tabSelected">
            <e-tabitems>
                <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
            </e-tabitems>
        </ejs-tab>
    </div>
</template>
<script setup>

import { TabComponent as EjsTab, TabItemsDirective as ETabitems, TabItemDirective as ETabitem } from '@syncfusion/ej2-vue-navigations';
import { enableRipple, createElement } from '@syncfusion/ej2-base';
import { ref, onMounted } from 'vue';

enableRipple(true);

const TabInstance = ref(null);
const headerText0 = { 'text': 'Tab1' };
const headerText1 = { 'iconCss': 'e-add-icon' };
const content0 = '#tab1_content';
const content1 = '#form-container';

onMounted(() => {
    let addBtn = document.querySelectorAll(".e-ileft.e-icon");
    addBtn[0].setAttribute("title", "Add Tab");
});

const tabSelected = (args) => {
    if (args.selectedIndex === document.querySelectorAll('#dynamic_tab .e-toolbar-item').length - 1) {
        document.getElementById('tab-title').value = '';
        document.getElementById('tab-content').value = '';
    }
};
const btnClicked = () => {
    let title = document.getElementById('tab-title').value;
    let content = document.getElementById('tab-content').value;
    var tabObj = TabInstance.value.ej2Instances;
    let item = { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };
    let totalItems = document.querySelectorAll('#dynamic_tab .e-toolbar-item').length;
    tabObj.addTab([item], totalItems - 1);
};

</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.e-content .e-item {
    font-size: 12px;
    margin: 10px;
    text-align: justify;
}

.container {
    min-width: 350px;
    max-width: 500px;
    margin: 0 auto;
}

#form-container {
    margin: 0 auto;
    max-width: 300px;
}

.btn-section {
    text-align: center;
}

.add-tab-btn-section td {
    padding: 10px;
}

.info {
    font-weight: bold;
}

.e-add-icon::before {
    content: '\e823';
}
</style>
<template>
    <div id="app">
        <div id='tab1_content' style='display: none'>
            <ul>
                <li>Click on the "+" header to add dynamic tab items. </li>
                <li>It displays input elements to get the new tab information. </li>
                <li>Add details and click the "Add Tab" button to open the newly added tab.</li>
            </ul>
        </div>
        <div id='form-container' style='display: none'>
            <div class='e-float-input'>
                <input type='text' id='tab-title' required="" />
                <span class='e-float-line'></span>
                <label class='e-float-text'>Enter header title</label>
            </div>
            <br />
            <div class='e-float-input'>
                <textarea rows='5' type='text' id='tab-content' required=""></textarea>
                <span class='e-float-line'></span>
                <label class='e-float-text'>Enter content</label>
            </div>
            <br />
            <div class='btn-section'>
                <button id='btn-add' class='e-btn' v-on:click='btnClicked'>Add Tab</button>
                <br />
                <br />
                <span class='info'> * Title is mandatory to add a new Tab</span>
            </div>
        </div>
        <ejs-tab id='dynamic_tab' ref='TabInstance' :selected="tabSelected">
            <e-tabitems>
                <e-tabitem :header='headerText0' :content="content0"></e-tabitem>
                <e-tabitem :header='headerText1' :content="content1"></e-tabitem>
            </e-tabitems>
        </ejs-tab>
    </div>
</template>
<script>

import { TabComponent, TabItemsDirective, TabItemDirective } from '@syncfusion/ej2-vue-navigations';
import { enableRipple, createElement } from '@syncfusion/ej2-base';

enableRipple(true);
export default {
    name: "App",
    components: {
        "ejs-tab": TabComponent,
        "e-tabitems": TabItemsDirective,
        "e-tabitem": TabItemDirective
    },
    data: function () {
        return {
            totalItems: 0,
            headerText0: { 'text': 'Tab1' },
            headerText1: { 'iconCss': 'e-add-icon' },
            content0: '#tab1_content',
            content1: '#form-container',
        }
    },

    mounted: function () {
        let addBtn = document.querySelectorAll(".e-ileft.e-icon");
        addBtn[0].setAttribute("title", "Add Tab");
    },

    methods: {
        tabSelected: function (args) {
            if (args.selectedIndex === document.querySelectorAll('#dynamic_tab .e-toolbar-item').length - 1) {
                document.getElementById('tab-title').value = '';
                document.getElementById('tab-content').value = '';
            }
        },
        btnClicked: function () {
            let title = document.getElementById('tab-title').value;
            let content = document.getElementById('tab-content').value;
            var tabObj = this.$refs.TabInstance.ej2Instances;
            let item = { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

            let totalItems = document.querySelectorAll('#dynamic_tab .e-toolbar-item').length;
            tabObj.addTab([item], totalItems - 1);
        }
    }
}
</script>
<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

#container {
    visibility: hidden;
}

#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.e-content .e-item {
    font-size: 12px;
    margin: 10px;
    text-align: justify;
}

.container {
    min-width: 350px;
    max-width: 500px;
    margin: 0 auto;
}

#form-container {
    margin: 0 auto;
    max-width: 300px;
}

.btn-section {
    text-align: center;
}

.add-tab-btn-section td {
    padding: 10px;
}

.info {
    font-weight: bold;
}

.e-add-icon::before {
    content: '\e823';
}
</style>

Load tab items dynamically in React Tab component

29 Aug 202313 minutes to read

Tabs can be added dynamically by passing array of items and index value to the addTab method.

    // New tab title and content inputs are fetched and stored in local variable
    let title: string = document.getElementById('tab-title').value;
    let content: string = document.getElementById('tab-content').value;

    // Required tab item object formed by using textbox inputs
    let item: Object =  { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

    // Item object and the index argument passed into the addTab method to add a new tab
    this.addTab([item], this.totalItems-1);

In the following demo, you can add the tab content by clicking the +. This + icon is added on the tab header using iconCss property. Enter the new Tab heading and content details in the available text boxes, click ‘Add Tab’ button to pass the details as an array and here last index is calculated to append the new tab at the end.

import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective } from '@syncfusion/ej2-react-navigations';
import { Tooltip } from '@syncfusion/ej2-popups';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
function App() {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    let tabInstance;
    const tabCreated = () => {
        const tooltip = new Tooltip({
            content: 'Add Tab'
        });
        tooltip.appendTo('.e-ileft.e-icon');
        document.getElementById('btn-add').onclick = (e) => {
            const title = document.getElementById('tab-title').value;
            const content = document.getElementById('tab-content').value;
            const ele = document.createElement("pre");
            ele.innerHTML = content.replace(/\n/g, "<br>\n");
            // tslint:disable-next-line: ban-types
            const item = { header: { text: title }, content: ele.outerHTML };
            const totalItems = document.querySelectorAll('#element .e-toolbar-item').length;
            document.getElementById('tabelement').ej2_instances[0].addTab([item], totalItems - 1);
        };
    };
    const tabSelected = (args) => {
        if (args.selectedIndex === document.querySelectorAll('#element .e-toolbar-item').length - 1) {
            document.getElementById('tab-title').value = '';
            document.getElementById('tab-content').value = '';
        }
    };
    let headertext;
    headertext = [{ text: "Twitter" }, { 'iconCss': 'e-add-icon' }];
    return (<TabComponent id='tabelement' ref={tab => tabInstance = tab} created={tabCreated} selected={tabSelected}>
      <TabItemsDirective>
        <TabItemDirective header={headertext[0]} content={'#tab1_content'}/>
        <TabItemDirective header={headertext[1]} content={'#form-container'}/>
      </TabItemsDirective>
    </TabComponent>);
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { TabComponent, TabItemDirective, TabItemsDirective, SelectEventArgs } from '@syncfusion/ej2-react-navigations';
import { Tooltip } from '@syncfusion/ej2-popups';
import { enableRipple } from '@syncfusion/ej2-base';

enableRipple(true);

function App() {
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  let tabInstance: TabComponent | any;

  const tabCreated = (): void => {
    const tooltip: Tooltip = new Tooltip({
      content: 'Add Tab'
    });
    tooltip.appendTo('.e-ileft.e-icon');

    (document.getElementById('btn-add') as any).onclick = (e: Event) => {
      const title: string = (document.getElementById('tab-title') as any).value;
      const content: string = (document.getElementById('tab-content') as any).value;
      const ele = document.createElement("pre");
      ele.innerHTML = content.replace(/\n/g, "<br>\n");
      // tslint:disable-next-line: ban-types
      const item: Object = { header: { text: title }, content: ele.outerHTML };
      const totalItems = document.querySelectorAll('#element .e-toolbar-item').length;
      (document.getElementById('tabelement') as any).ej2_instances[0].addTab([item], totalItems - 1);
    };
  }

  const tabSelected = (args: SelectEventArgs): any => {
    if (args.selectedIndex === document.querySelectorAll('#element .e-toolbar-item').length - 1) {
      (document.getElementById('tab-title') as any).value = '';
      (document.getElementById('tab-content') as any).value = '';
    }
  }

  let headertext: any;
  headertext = [{ text: "Twitter" }, { 'iconCss': 'e-add-icon' }];

  return (
    <TabComponent id='tabelement' ref={tab => tabInstance = tab} created={tabCreated} selected={tabSelected}>
      <TabItemsDirective>
        <TabItemDirective header={headertext[0]} content={'#tab1_content'} />
        <TabItemDirective header={headertext[1]} content={'#form-container'} />
      </TabItemsDirective>
    </TabComponent>
  );
}
const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/material.css" rel="stylesheet" />
    <link href="index.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='container'>
            <div id="tab1_content" style="display: none">
                    <ul>
                        <li>Click on the "+" header to add dynamic tab items. </li>
                        <li>It displays input elements to get the new tab information. </li>
                        <li>Add details and click the "Add Tab" button to open the newly added tab.</li>
                    </ul>
                </div>
                <div id="form-container" style="display: none">
                    <div class="e-float-input">
                        <input type="text" id="tab-title" required="" />
                        <span class="e-float-line"></span>
                        <label class="e-float-text">Enter header title</label>
                    </div>
                    <br />
                    <div class="e-float-input">
                        <textarea rows="5" type="text" id="tab-content" required=""></textarea>
                        <span class="e-float-line"></span>
                        <label class="e-float-text">Enter content</label>
                    </div>
                    <br />
                    <div class="btn-section">
                        <button id="btn-add" class="e-btn">Add Tab</button>
                        <br />
                        <br />
                        <span class="info"> * Title is mandatory to add a new Tab</span>
                    </div>
                </div>
        <div id='element'>
            <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>

Syncfusion AI Assistant

How can I help you?

Load tab items dynamically in Angular Tab component

19 Sep 20255 minutes to read

Tabs can be added dynamically by passing an array of items and index value to the addTab method.

    // New tab title and content inputs are fetched and stored in local variable
    let title: string = document.getElementById('tab-title').value;
    let content: string = document.getElementById('tab-content').value;

    // Required tab item object formed by using textbox inputs
    let item: Object =  { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

    // Item object and the index argument passed into the addTab method to add a new tab
    this.tabInstance.addTab([item], this.totalItems-1);

In the following demo, tab content can be added by clicking the + icon. This + icon is added to the tab header using the iconCss property. Enter the new Tab heading and content details in the available text boxes, then click the ‘Add Tab’ button. The details are passed as an array, and the new tab is appended at the end using the calculated last index.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TabModule } from '@syncfusion/ej2-angular-navigations'




import { Tooltip } from '@syncfusion/ej2-popups';
import { Component, ViewChild } from '@angular/core';
import { enableRipple, createElement } from '@syncfusion/ej2-base';
import { SelectEventArgs, TabComponent } from '@syncfusion/ej2-angular-navigations';

enableRipple(true);

/**
 * Add new tabs dynamically
 */

@Component({
imports: [
        FormsModule, TabModule
    ],


standalone: true,
    selector: 'app-container',
    template: `<ejs-tab #element id="element" (created)="tabCreated()" (selected)="tabSelected($event)">
            <e-tabitems>
                <e-tabitem [header]='headerText[0]' content="#tab1_content"></e-tabitem>
                <e-tabitem [header]='headerText[1]' content="#form-container"></e-tabitem>
            </e-tabitems>
        </ejs-tab>`
})

export class AppComponent {
      @ViewChild('element') tabInstance?: TabComponent;

    public totalItems?: number;
    public headerText: { text?: string, iconCss?: string }[] = [{ 'text': 'Tab1' }, { 'iconCss': 'e-add-icon' }];
    public tabCreated(): void {
        let tooltip: Tooltip = new Tooltip({
            content: 'Add Tab'
        });
        tooltip.appendTo('.e-ileft.e-icon');

        (document.getElementById('btn-add') as HTMLElement).onclick = (e : Event) => {
            let title: string = (document.getElementById('tab-title') as any).value;
            let content: string = (document.getElementById('tab-content') as any).value;
            let item: Object =  { header: { text: title }, content: createElement('pre', { innerHTML: content.replace(/\n/g, '<br>\n') }).outerHTML };

            this.totalItems = document.querySelectorAll('#element .e-toolbar-item').length;
            this.tabInstance?.addTab([item], this.totalItems-1);
        };
    }

    public tabSelected(args: SelectEventArgs): void {
        if (args.selectedIndex === document.querySelectorAll('#element .e-toolbar-item').length -1) {
            (document.getElementById('tab-title') as any).value = '';
            (document.getElementById('tab-content') as any).value = '';
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));